import { ComponentTag, WebCellProps, FunctionComponent } from './utility';
import { WebCellClass } from './WebCell';
export interface AsyncBoxProps extends WebCellProps {
    loader: () => Promise<ComponentTag>;
}
declare const AsyncBox_base: WebCellClass<AsyncBoxProps>;
export declare class AsyncBox extends AsyncBox_base {
    loader: AsyncBoxProps['loader'];
    component?: ComponentTag;
    get delegatedProps(): any;
    connectedCallback(): void;
    protected load: () => Promise<void>;
    render(): import("snabbdom").VNode;
}
declare type GetAsyncProps<T> = T extends () => Promise<{
    default: FunctionComponent<infer P> | WebCellClass<infer P>;
}> ? P : {};
export declare function lazy<T extends () => Promise<{
    default: FunctionComponent | WebCellClass;
}>>(loader: T): (props: GetAsyncProps<T>) => import("snabbdom").VNode;
export {};
